// SampleImageDoc.cpp : implementation of the CSampleImageDoc class
//

#include "stdafx.h"
#include "Sample.h"

#include "SampleImageDoc.h"
#include "SampleImageView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleImageDoc

IMPLEMENT_DYNCREATE(CSampleImageDoc, CDocument)

BEGIN_MESSAGE_MAP(CSampleImageDoc, CDocument)
	//{{AFX_MSG_MAP(CSampleImageDoc)
	ON_COMMAND(ID_READ_ONLY, OnReadOnly)
	ON_UPDATE_COMMAND_UI(ID_READ_ONLY, OnUpdateReadOnly)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleImageDoc construction/destruction

#pragma warning(disable:4355)
CSampleImageDoc::CSampleImageDoc()
  : m_readOnly(false)
{
	// TODO: add one-time construction code here
}

CSampleImageDoc::~CSampleImageDoc()
{
}

BOOL CSampleImageDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_gflBitmap.clear();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSampleImageDoc serialization

void CSampleImageDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSampleImageDoc diagnostics

#ifdef _DEBUG
void CSampleImageDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSampleImageDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSampleImageDoc commands

void CSampleImageDoc::DeleteContents() 
{
	CDocument::DeleteContents();

	m_gflBitmap.clear();
}

BOOL CSampleImageDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	if (!m_gflBitmap.load(lpszPathName))
	{
		AfxMessageBox("Error loading file...", MB_OK ); 
		return FALSE;
	}

	return TRUE;
}

BOOL CSampleImageDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	if (!m_gflBitmap.save(lpszPathName))
	{
		AfxMessageBox("Error saving file...", MB_OK ); 
		return FALSE;
	}


	POSITION pos = GetFirstViewPosition();
	while (pos != NULL)
	{
		CSampleImageView* pView = (CSampleImageView*)GetNextView(pos);
		pView->OnSetFileName(lpszPathName);
	}

	return TRUE;	//	Note - we didn't call inherited member!
}

void CSampleImageDoc::OnReadOnly() 
{
	if (!m_readOnly)
	{
		m_readOnly = true;
		AfxMessageBox("Document now read-only!");
	}
	else
		m_readOnly = false;
}

void CSampleImageDoc::OnUpdateReadOnly(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_readOnly);
}

