// SampleImageView.h : interface of the CSampleImageView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAMPLEIMAGEVIEW_H__INCLUDED_)
#define AFX_SAMPLEIMAGEVIEW_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSampleImageDoc;

class CSampleImageView : public CView
{
protected: // create from serialization only
	CSampleImageView();
	DECLARE_DYNCREATE(CSampleImageView)

// Attributes
public:
	CSampleImageDoc* GetDocument();

	//virtual CCrystalTextBuffer *LocateTextBuffer();

	void OnSetFileName(LPCTSTR lpszPathName);
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSampleImageView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSampleImageView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	int m_nScreenHeight;
	int m_nScreenWidth;
	int m_nTopY, m_nLeftX;
	int m_nMagnification;
	int m_nXoffset, m_nYoffset;
	CPoint m_ptMousePos;
	int GetScreenWidth();
	int GetScreenHeight();
	int GetImageHeight();
	int GetImageWidth();

	void RecalcVertScrollBar(BOOL bPositionOnly = FALSE);
	void RecalcHorzScrollBar(BOOL bPositionOnly = FALSE);

private:
	//	Painting caching bitmap
	CBitmap *m_pCacheBitmap;

// Generated message map functions
protected:
	//{{AFX_MSG(CSampleImageView)
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSelectCppColorer();
	afx_msg void OnSelectCDFColorer();
	afx_msg void OnSelectHTMLColorer();
	afx_msg void OnSelectXMLColorer();
	afx_msg void OnSelectJavaScriptColorer();
	afx_msg void OnSelectcvbColorer();
	afx_msg void OnSelectNoColorer();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg void OnUpdateIndicatorPosition(CCmdUI* pCmdUI);
};

#ifndef _DEBUG  // debug version in SampleImageView.cpp
inline CSampleImageDoc* CSampleImageView::GetDocument()
   { return (CSampleImageDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAMPLEIMAGEVIEW_H__INCLUDED_)
